package egg_energy

import (
	"code.fnuoos.com/EggPlanet/egg_system_rules.git/enum"
	md2 "code.fnuoos.com/EggPlanet/egg_system_rules.git/md"
	"code.fnuoos.com/EggPlanet/egg_system_rules.git/rule"
	"code.fnuoos.com/EggPlanet/egg_system_rules.git/rule/egg_energy/md"
	egg_system_rules "code.fnuoos.com/EggPlanet/egg_system_rules.git/utils"
	zhios_order_relate_logx "code.fnuoos.com/EggPlanet/egg_system_rules.git/utils/logx"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"fmt"
	"xorm.io/xorm"
)

// ActivityCoinStartExchangeEggTeamEnergy 团队蛋蛋积分【开始】兑换成团队蛋蛋能量
func ActivityCoinStartExchangeEggTeamEnergy(engine *xorm.Engine, req md.EggEnergyStructForStartExchangeGreenEnergy, ch *rabbit.Channel) (err error) {
	session := engine.NewSession()
	defer func() {
		session.Close()
		if err := recover(); err != nil {
			_ = zhios_order_relate_logx.Error(err)
		}
	}()
	session.Begin()

	//1、扣除用户对应蛋蛋活跃积分数量
	err = rule.DealUserVirtualCoin(session, md2.DealUserVirtualCoinReq{
		Kind:         "sub",
		Title:        enum.EggPointCoinToExchangeToTeamEggEnergy.String(),
		TransferType: int(enum.EggPointCoinToExchangeToTeamEggEnergy),
		CoinId:       req.PointCoinId,
		Uid:          req.Uid,
		Amount:       egg_system_rules.StrToFloat64(req.Amount),
	})
	if err != nil {
		fmt.Println("ActivityCoinStartExchangeEggTeamEnergy:::::err111:::", err)
		_ = session.Rollback()
		return
	}

	//TODO::推入rabbitmq 异步处理
	ch.Publish(md.EggEnergyExchange, md.EggEnergyStructForAutoExchangeGreenEnergy{
		Uid:                    req.Uid,
		EnergyCoinId:           req.EnergyCoinId,
		AutoExchangeNumsAmount: req.AutoExchangeNumsAmount,
		StartExchangeTime:      req.StartExchangeTime,
		EndExchangeTime:        req.StartExchangeTime,
	}, md.EggEnergyRoutKeyForAutoExchangeGreenEnergyToTeam)

	return session.Commit()
}
