package md

type VipEquitySettingStruct struct {
	VipLevelId                string `json:"vip_level_id"`                 //会员等级id
	ExchangeAccountBalanceFee string `json:"exchange_account_balance_fee"` //兑换余额手续费
	DividendRatio             string `json:"dividend_ratio"`               //分红比例
}

type TeamRewardSettingStruct struct {
	RewardDecrementValue          string `json:"reward_decrement_value"`              //递减百分比
	RewardEndValue                string `json:"reward_end_value"`                    //奖励结束值
	MemberSelfIsOpenGetTeamReward string `json:"member_self_is_open_get_team_reward"` //会员是否活跃得到团队奖励
	OneRoundDuration              string `json:"one_round_duration"`                  //一轮持续时间
}

type SignInRewardStruct struct {
	VipMemberStartNums string `json:"vip_member_start_nums"` //会员起始数量
	VipMemberEndNums   string `json:"vip_member_end_nums"`   //会员结束数量
	RewardValue        string `json:"reward_value"`          //奖励值
}

type PriceSettingStruct struct {
	PriceHigherThanValue                                          string `json:"price_higher_than_value"`                                              //高于x元
	MarketplaceMerchantsNumsExchangeMarketplaceMerchantsFundValue string `json:"marketplace_merchants_nums_exchange_marketplace_merchants_fund_value"` //市商数量单笔x数量自动兑换
	PriceBelowValue                                               string `json:"price_below_value"`                                                    //低于x元
	MarketplaceMerchantsFundExchangeMarketplaceMerchantsNumsValue string `json:"marketplace_merchants_fund_exchange_marketplace_merchants_nums_value"` //市商资金单笔x元自动兑换
}

type DestructionSettingStruct struct {
	DestructionQuantity     string `json:"destruction_quantity"`       //销毁百分比
	PublicWelfareAndCharity string `json:"public_welfare_and_charity"` //公益慈善百分比
	DevelopmentCommittee    string `json:"development_committee"`      //发展委员会百分比
	StarLevelDividends      string `json:"star_level_dividends"`       //星级分红百分比
	MarketplaceMerchant     string `json:"marketplace_merchant"`       //市商数量百分比
	CommunityDividends      string `json:"community_dividends"`        //社区分红百分比
}

const DealUserCoinRequestIdPrefix = "egg_deal_user_coin:%d:uid:%d"

type AddPublicPlatoonUserRelationCommissionReq struct {
	Uid          string `json:"uid"`
	RecommendUid string `json:"recommend_uid"` //推荐人uid
}

type VideoRewardSystemStruct struct {
	RewardValue     string `json:"reward_value"`     //奖励X个活跃积分
	RewardTotalNum  string `json:"reward_total_num"` //一共X个奖励视屏
	IntervalMinutes string `json:"interval_minutes"` //间隔X秒
	EachRoundHour   string `json:"each_round_hour"`  //每一轮X个小时
}

type RewardSystemStruct struct {
	Level           int    `json:"level"`            //圈层
	RewardCondition string `json:"reward_condition"` //奖励条件
	RewardValue     string `json:"reward_value"`     //奖励值
}

type ExchangeRulesStruct struct {
	AutoExchangeNumsByPerson string `json:"auto_exchange_nums_by_person"` //个人数量X个，自动兑换可用蛋蛋能量
	AutoExchangeRateByPerson string `json:"auto_exchange_rate_by_person"` //个人数量百分比，自动兑换可用蛋蛋能量
	AutoExchangeNumsByTeam   string `json:"auto_exchange_nums_by_team"`   //团队数量X个，自动兑换团队蛋蛋能量
	AutoExchangeRateByTeam   string `json:"auto_exchange_rate_by_team"`   //团队数量百分比，自动兑换团队蛋蛋能量
}

const UserNextWatchAdDate = "user_next_watch_date:%d"

type CalcPriceIncreaseFormulaResp struct {
	GetEggEnergyNums       string `json:"get_egg_energy_nums"`       //得到蛋蛋能量的数量
	BeforePrice            string `json:"before_price"`              //变更前-价格
	AfterPrice             string `json:"after_price"`               //变更后-价格
	BeforePlanetTotalValue string `json:"before_planet_total_value"` //变更前-星球总价值
	AfterPlanetTotalValue  string `json:"after_planet_total_value"`  //变更后-星球总价值
	BeforeEnergyTotalNums  string `json:"before_energy_total_nums"`  //变更前-现行总量
	AfterEnergyTotalNums   string `json:"after_energy_total_nums"`   //变更后-现行总量
}

type CalcPriceReductionFormulaResp struct {
	GetEggEnergyAmount     string `json:"get_egg_energy_amount"`     //得到蛋蛋能量的钱
	BeforePrice            string `json:"before_price"`              //变更前-价格
	AfterPrice             string `json:"after_price"`               //变更后-价格
	BeforePlanetTotalValue string `json:"before_planet_total_value"` //变更前-星球总价值
	AfterPlanetTotalValue  string `json:"after_planet_total_value"`  //变更后-星球总价值
	BeforeEnergyTotalNums  string `json:"before_energy_total_nums"`  //变更前-现行总量
	AfterEnergyTotalNums   string `json:"after_energy_total_nums"`   //变更后-现行总量
}

type DealAvailableEggEnergyCoinReq struct {
	Amount                 string `json:"amount"`                    //变更数量
	AmountFee              string `json:"amount_fee"`                //手续费
	BeforePrice            string `json:"before_price"`              //变更前-价格
	AfterPrice             string `json:"after_price"`               //变更后-价格
	BeforePlanetTotalValue string `json:"before_planet_total_value"` //变更前-星球总价值
	AfterPlanetTotalValue  string `json:"after_planet_total_value"`  //变更后-星球总价值
	BeforeEnergyTotalNums  string `json:"before_energy_total_nums"`  //变更前-现行总量
	AfterEnergyTotalNums   string `json:"after_energy_total_nums"`   //变更后-现行总量
}

type NewUserRewardRules struct {
	InviteUserRewardValue int     `json:"invite_user_reward_value"` //拉新用户奖励x个活跃积分
	RewardCoefficient     float64 `json:"reward_coefficient"`       //奖励系数
	ContinueDays          int     `json:"continue_days"`            //连续x天
}
